.k8s-deploy-template:
  # this template needs: DEV_KUBE_CONFIG (kubeconfig, base64 encoded), KUBE_NAMESPACE, SERVICE_NAME, SERVICE_PORT
  # SERVICE_NAME & SERVICE_PORT can also defined in a values.yml file
  image: docker:latest
  services: []
  variables:
    KUBERNETES_VERSION: v1.16.6
    HELM_VERSION: v3.1.0
    KUBECONFIG: /deploy-kubeconfig
    HELM_CHART: deploy/service-template/

  before_script:
    - echo "$DEV_KUBE_CONFIG" | base64 -d > "$KUBECONFIG"

    - apk add -U openssl curl tar gzip bash ca-certificates git 
    - curl "https://get.helm.sh/helm-${HELM_VERSION}-linux-amd64.tar.gz" | tar zx
    - mv linux-amd64/helm /usr/bin/

    - curl -L -o /usr/bin/kubectl "https://storage.googleapis.com/kubernetes-release/release/${KUBERNETES_VERSIO  N}/bin/linux/amd64/kubectl"
    - chmod +x /usr/bin/kubectl
    # TODO fail if kubectl version diff is > 0.1

  script:
    - if [ -f deploy/values.yml ] ; then export VALUES_FILE="-f deploy/values.yml" ; fi
    - helm upgrade --install --wait
        $VALUES_FILE
        --namespace="$KUBE_NAMESPACE"
        --set-string service.name="$SERVICE_NAME"
        --set-string service.port="$SERVICE_PORT"
        --set-string commit.rev="$CI_COMMIT_SHORT_SHA"
        --set-string image.name="$CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA"
        "$SERVICE_NAME" "$HELM_CHART"
    - kubectl rollout status -n "$KUBE_NAMESPACE" -w "deployment/$SERVICE_NAME"
